## brewtarget 4.0.17

=== CMakeLists.txt ===
#╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌
# CMakeLists.txt is part of Brewtarget, and is Copyright the following authors 2009-2024
#  - Chris Pavetto <chrispavetto@gmail.com>
#  - Dan Cavanagh <dan@dancavanagh.com>
#  - Daniel Moreno <danielm5@users.noreply.github.com>
#  - Daniel Pettersson <pettson81@gmail.com>
#  - Kregg Kemper <gigatropolis@yahoo.com>
#  - Matt Young <mfsy@yahoo.com>
#  - Maxime Lavigne (malavv) <duguigne@gmail.com>
#  - Mik Firestone <mikfire@gmail.com>
#  - Philip Greggory Lee <rocketman768@gmail.com>
#  - Robby Workman <rworkman@slackware.com>
#  - Théophane Martin <theophane.m@gmail.com>
#
# Brewtarget is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Brewtarget is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌╌

# ⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐
# NB: Meson and the `bt` build tool Python script are now the primary way of building and packaging the software.  You
#     can also still CMake to compile the product and install it locally, but we no longer support using CMake to do
#     packaging.  (Over time the intention is to remove packaging-specific code from this script, not least as it does
#     not work properly on Mac and Windows.)
# ⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐⭐

#
# Creates a Makefile in the build directory, from where you can do builds and installs.
#
# NOTE: cmake . -DCMAKE_INSTALL_PREFIX=/tmp/blah && make DESTDIR=/foo
# will install to /foo/tmp/blah.
#
# See also - src/CMakeLists.txt
#
# Standard make targets:
#   * make                  -  Regenerate the makefile if necessary and compile the source code.  (On Linux, also
#                              converts the markdown list of changes (CHANGES.markdown) to Debian package format
#                              changelog.)
#
#                              NB: Other make targets will NOT regenerate the makefile from this CMakeLists.txt file.
#                              That means that, if you make a change that affects "make package" or "make clean" etc,
#                              you must run "make" before you run "make package" or "make clean" etc, otherwise your
#                              change will not be picked up.  (If necessary, you can interrupt the build that "make"
#                              kicks off, as, by that point, the makefile will be updated.)
#
#   * make clean            -  Delete compiled objects so next build starts from scratch
#   * sudo make install     -  Install locally
#   * make test             -  Run unit tests via CTest
#
# Custom make targets:
#   * make source_doc       -  Makes Doxygen HTML documentation of the source in doc/html
#   * make install-data
#   * make install-runtime
#
# CMake options
#   * CMAKE_INSTALL_PREFIX  - /usr/local by default. Set this to /usr on Debian-based systems like Ubuntu.
#   * DO_RELEASE_BUILD      - OFF by default. If ON, will do a release build. Otherwise, debug build.
#   * NO_MESSING_WITH_FLAGS - OFF by default. ON means do not add any build flags whatsoever. May override other options.
# NOTE: You need to run CMake to change the options (you can't change them just by running make, not even by running
# make clean.  Eg, in the build directory, run the following to switch to debug builds:
#     cmake -DDO_RELEASE_BUILD=OFF ..
#

# Uncomment the next "set" line for slightly verbose build output
# Alternatively, for very verbose output, invoke make as follows:
#
#    make VERBOSE=1
#
# On Windows, you need:
#
#    cmake --build . --verbose
#
#set(CMAKE_VERBOSE_MAKEFILE ON)

#=======================================================================================================================
#================================================= CMake Configuration =================================================
#=======================================================================================================================
cmake_minimum_required(VERSION 3.16)
cmake_policy(VERSION 3.16)
# Ensure we are using modern behaviour of the project command (introduced in CMake 3.0) which enables setting version
# numbers via it (rather than manually setting individual major/minor/patch vars).
cmake_policy(SET CMP0048 NEW)

# Compatibility settings used with modern CMAKE (>= 3.29) used to pull BoostConfig.cmake from upstream
# -> FindBoost cmake module was removed in recent versions.
# See https://cmake.org/cmake/help/latest/module/FindBoost.html
if(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER_EQUAL 3.29)
cmake_policy(SET CMP0167 NEW)
endif()

#=======================================================================================================================
#================================================ Other preliminaries =================================================
#=======================================================================================================================
# Set the target binary architecture for targets on macOS
if(APPLE AND NOT CMAKE_OSX_ARCHITECTURES)
   # Per https://cmake.org/cmake/help/latest/variable/CMAKE_OSX_ARCHITECTURES.html, "the value of this variable should
   # be set prior to the first project() or enable_language() command invocation because it may influence configuration
   # of the toolchain and flags".
   set(CMAKE_OSX_ARCHITECTURES x86_64, arm64) # Build both x86_64 and arm64 for Apple silicon.
   #set(CMAKE_OSX_ARCHITECTURES i386 x86_64) # Build intel binary.
   #set(CMAKE_OSX_ARCHITECTURES ppc i386 ppc64 x86_64) # Build universal binary.
endif()

#=======================================================================================================================
#============================================== Project name and Version ===============================================
#=======================================================================================================================
# It's simplest to keep the project name all lower-case as it means we can use a lot more of the default settings for
# Linux packaging (where directory names etc are expected to be all lower-case).
project(brewtarget VERSION 4.0.17 LANGUAGES CXX)
message(STATUS "Building ${PROJECT_NAME} version ${PROJECT_VERSION}")
message(STATUS "PROJECT_SOURCE_DIR is ${PROJECT_SOURCE_DIR}")
# Sometimes we do need the capitalised version of the project name
set(capitalisedProjectName Brewtarget)
# We use this in the program, to tell users where to get support.
set(CONFIG_GITHUB_URL "https://github.com/${capitalisedProjectName}/${projectName}")
set(CONFIG_WEBSITE_URL "https://www.brewtarget.beer/")
set(CONFIG_ORGANIZATION_DOMAIN "brewken.com")

#=======================================================================================================================
#======================================================= Options =======================================================
#=======================================================================================================================
option(DO_RELEASE_BUILD "If on, will do a release build. Otherwise, debug build." OFF)
option(NO_MESSING_WITH_FLAGS "On means do not add any build flags whatsoever. May override other options." OFF)

#=======================================================================================================================
#===================================================== Directories =====================================================
#=======================================================================================================================

#================================================== Source directories =================================================
#
# ${repoDir}                   = the directory containing this (CMakeLists.txt) file
# ${repoDir}/src               = C++ source code
# ${repoDir}/ui                = QML UI layout files
# ${repoDir}/data              = Binary files, including sounds and default database
# ${repoDir}/translations      = Translated texts
# ${repoDir}/mac               = Mac-specific files (desktop icon)
# ${repoDir}/win               = Windows-specific files (desktop icon)
# ${repoDir}/packaging         = Packaging-related config
#
set(repoDir "${CMAKE_CURRENT_SOURCE_DIR}")

# Location of custom CMake modules. (At the moment, there is only one, which is used for Windows packaging
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules")

#================================================= Install directories =================================================
# Note that WIN32 is true "when the target system is Windows, including Win64" (see
# https://cmake.org/cmake/help/latest/variable/WIN32.html), so this is ALL versions of Windows, not just 32-bit.
# UNIX is true when the "the target system is UNIX or UNIX-like", so it is set when we're building for Mac and for
# Linux.  There is a separate flag (APPLE) when we're building for Mac, but, AFAICT, no specific flag for Linux.
#
if(UNIX AND NOT APPLE)
   #============================================= Linux Install Directories ============================================
   # By default, CMAKE_INSTALL_PREFIX is:
   #   - /usr/local                           on Linux (& Mac)
   #   - c:/Program Files/${PROJECT_NAME}     on Windows
   #
   # On a lot of Linux distros, including Debian and derived systems (such as Ubuntu), it's more normal for pretty much
   # all user-installed apps to go in /usr/bin rather than /usr/local/bin, so CMAKE_INSTALL_PREFIX can be overridden on
   # the command line via "--prefix usr"
   #
   # (See http://lists.busybox.net/pipermail/busybox/2010-December/074114.html for a great, albeit slightly depressing,
   # explanation of why there are so many places for binaries to live on Unix/Linux systems.  FWIW, the current
   # "standards" for Linux are at https://refspecs.linuxfoundation.org/fhs.shtml but these are open to interpretation.)
   #
   # .:TBD: We also allow -DEXEC_PREFIX=/usr (used in .github/workflows/linux-ubuntu.yml) but I'm not sure if this is
   #        needed or could be replaced by "--prefix usr"
   #
   # Debian standard directories.
   if(NOT EXEC_PREFIX)
      set(EXEC_PREFIX ${CMAKE_INSTALL_PREFIX})
   endif()

   set(installSubDir_data         "share/${CMAKE_PROJECT_NAME}")
   set(installSubDir_doc          "share/doc/${CMAKE_PROJECT_NAME}")
   set(installSubDir_bin          "bin")
   # According to https://specifications.freedesktop.org/menu-spec/menu-spec-1.0.html#paths, .desktop files need to live
   # in one of the $XDG_DATA_DIRS/applications/.  (Note that $XDG_DATA_DIRS is a colon-separated list of directories, typically
   # defaulting to /usr/local/share/:/usr/share/. but on another system it might be
   # /usr/share/plasma:/usr/local/share:/usr/share:/var/lib/snapd/desktop:/var/lib/snapd/desktop).  When combined with
   # CMAKE_INSTALL_PREFIX, "share/applications" should end up being one of these.
   set(installSubDir_applications "share/applications")
   # It's a similar but slightly more complicated story for where to put icons.  (See
   # https://specifications.freedesktop.org/icon-theme-spec/icon-theme-spec-latest.html#directory_layout for all the
   # details.)

=== src/CMakeLists.txt ===
#----------------------------------------------------------------------------------------------------------------------
# src/CMakeLists.txt is part of Brewtarget, and is copyright the following authors 2009-2024:
#   • Aidan Roberts <aidanr67@gmail.com>
#   • Daniel Moreno <danielm5@users.noreply.github.com>
#   • Mark de Wever <koraq@xs4all.nl>
#   • Mattias Måhl <mattias@kejsarsten.com>
#   • Matt Young<mfsy@yahoo.com>
#   • Maxime Lavigne <duguigne@gmail.com>
#   • Mik Firestone <mikfire@gmail.com>
#   • Philip Greggory Lee <rocketman768@gmail.com>
#   • Ryan Hoobler <rhoob@yahoo.com>
#   • Théophane Martin <theophane.m@gmail.com>
#
# Brewtarget is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# Brewtarget is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#----------------------------------------------------------------------------------------------------------------------
#
# See also ../CMakeLists.txt
#

#
# Variable that contains all the .cpp files in this project.
#
# You can recreate the body of this list by running the following from the bash prompt in the build directory:
#    find ../src -name '*.cpp' | LC_ALL=C sort | sed 's+^../src+    ${repoDir}/src+' | grep -v Testing.cpp | grep -v main.cpp
#
# It is tempting to ask ourselves why we don't have CMake figure out this list itself.  Well, according to the
# documentation (https://cmake.org/cmake/help/latest/command/file.html#filesystem) "We do not recommend using GLOB to
# collect a list of source files from your source tree. If no CMakeLists.txt file changes when a source is added or
# removed then the generated build system cannot know when to ask CMake to regenerate."
#
set(filesToCompile_cpp
    ${repoDir}/src/AboutDialog.cpp
    ${repoDir}/src/AlcoholTool.cpp
    ${repoDir}/src/Algorithms.cpp
    ${repoDir}/src/AncestorDialog.cpp
    ${repoDir}/src/Application.cpp
    ${repoDir}/src/BeerColorWidget.cpp
    ${repoDir}/src/BrewDayFormatter.cpp
    ${repoDir}/src/BrewDayScrollWidget.cpp
    ${repoDir}/src/BrewNoteWidget.cpp
    ${repoDir}/src/BtColor.cpp
    ${repoDir}/src/BtDatePopup.cpp
    ${repoDir}/src/BtFieldType.cpp
    ${repoDir}/src/BtHorizontalTabs.cpp
    ${repoDir}/src/BtSplashScreen.cpp
    ${repoDir}/src/BtTabWidget.cpp
    ${repoDir}/src/BtTextEdit.cpp
    ${repoDir}/src/ConverterTool.cpp
    ${repoDir}/src/HeatCalculations.cpp
    ${repoDir}/src/HelpDialog.cpp
    ${repoDir}/src/Html.cpp
    ${repoDir}/src/HydrometerTool.cpp
    ${repoDir}/src/IbuGuSlider.cpp
    ${repoDir}/src/InventoryFormatter.cpp
    ${repoDir}/src/LatestReleaseFinder.cpp
    ${repoDir}/src/Localization.cpp
    ${repoDir}/src/Logging.cpp
    ${repoDir}/src/MainWindow.cpp
    ${repoDir}/src/MashDesigner.cpp
    ${repoDir}/src/MashWizard.cpp
    ${repoDir}/src/NamedEntitySortProxyModel.cpp
    ${repoDir}/src/OgAdjuster.cpp
    ${repoDir}/src/OptionDialog.cpp
    ${repoDir}/src/PersistentSettings.cpp
    ${repoDir}/src/PitchDialog.cpp
    ${repoDir}/src/PrimingDialog.cpp
    ${repoDir}/src/PrintAndPreviewDialog.cpp
    ${repoDir}/src/RadarChart.cpp
    ${repoDir}/src/RangedSlider.cpp
    ${repoDir}/src/RecipeExtrasWidget.cpp
    ${repoDir}/src/RecipeFormatter.cpp
    ${repoDir}/src/RefractoDialog.cpp
    ${repoDir}/src/ScaleRecipeTool.cpp
    ${repoDir}/src/StrikeWaterDialog.cpp
    ${repoDir}/src/StyleRangeWidget.cpp
    ${repoDir}/src/TimerListDialog.cpp
    ${repoDir}/src/TimerMainDialog.cpp
    ${repoDir}/src/TimerWidget.cpp
    ${repoDir}/src/WaterDialog.cpp
    ${repoDir}/src/boiltime.cpp
    ${repoDir}/src/buttons/BoilButton.cpp
    ${repoDir}/src/buttons/EquipmentButton.cpp
    ${repoDir}/src/buttons/FermentationButton.cpp
    ${repoDir}/src/buttons/MashButton.cpp
    ${repoDir}/src/buttons/RecipeAttributeButton.cpp
    ${repoDir}/src/buttons/StyleButton.cpp
    ${repoDir}/src/buttons/WaterButton.cpp
    ${repoDir}/src/catalogs/EquipmentCatalog.cpp
    ${repoDir}/src/catalogs/FermentableCatalog.cpp
    ${repoDir}/src/catalogs/HopCatalog.cpp
    ${repoDir}/src/catalogs/MiscCatalog.cpp
    ${repoDir}/src/catalogs/StyleCatalog.cpp
    ${repoDir}/src/catalogs/YeastCatalog.cpp
    ${repoDir}/src/database/BtSqlQuery.cpp
    ${repoDir}/src/database/Database.cpp
    ${repoDir}/src/database/DatabaseSchemaHelper.cpp
    ${repoDir}/src/database/DbTransaction.cpp
    ${repoDir}/src/database/DefaultContentLoader.cpp
    ${repoDir}/src/database/ObjectStore.cpp
    ${repoDir}/src/database/ObjectStoreTyped.cpp
    ${repoDir}/src/editors/BoilEditor.cpp
    ${repoDir}/src/editors/BoilStepEditor.cpp
    ${repoDir}/src/editors/EquipmentEditor.cpp
    ${repoDir}/src/editors/FermentableEditor.cpp
    ${repoDir}/src/editors/FermentationEditor.cpp
    ${repoDir}/src/editors/FermentationStepEditor.cpp
    ${repoDir}/src/editors/HopEditor.cpp
    ${repoDir}/src/editors/MashEditor.cpp
    ${repoDir}/src/editors/MashStepEditor.cpp
    ${repoDir}/src/editors/MiscEditor.cpp
    ${repoDir}/src/editors/NamedMashEditor.cpp
    ${repoDir}/src/editors/StyleEditor.cpp
    ${repoDir}/src/editors/WaterEditor.cpp
    ${repoDir}/src/editors/YeastEditor.cpp
    ${repoDir}/src/measurement/Amount.cpp
    ${repoDir}/src/measurement/ColorMethods.cpp
    ${repoDir}/src/measurement/IbuMethods.cpp
    ${repoDir}/src/measurement/Measurement.cpp
    ${repoDir}/src/measurement/PhysicalQuantity.cpp
    ${repoDir}/src/measurement/SucroseConversion.cpp
    ${repoDir}/src/measurement/SystemOfMeasurement.cpp
    ${repoDir}/src/measurement/Unit.cpp
    ${repoDir}/src/measurement/UnitSystem.cpp
    ${repoDir}/src/model/Boil.cpp
    ${repoDir}/src/model/BoilStep.cpp
    ${repoDir}/src/model/BrewNote.cpp
    ${repoDir}/src/model/Equipment.cpp
    ${repoDir}/src/model/Fermentable.cpp
    ${repoDir}/src/model/Fermentation.cpp
    ${repoDir}/src/model/FermentationStep.cpp
    ${repoDir}/src/model/Folder.cpp
    ${repoDir}/src/model/Hop.cpp
    ${repoDir}/src/model/Ingredient.cpp
    ${repoDir}/src/model/IngredientInRecipe.cpp
    ${repoDir}/src/model/Instruction.cpp
    ${repoDir}/src/model/Inventory.cpp
    ${repoDir}/src/model/Mash.cpp
    ${repoDir}/src/model/MashStep.cpp
    ${repoDir}/src/model/Misc.cpp
    ${repoDir}/src/model/NamedEntity.cpp
    ${repoDir}/src/model/NamedParameterBundle.cpp
    ${repoDir}/src/model/OutlineableNamedEntity.cpp
    ${repoDir}/src/model/OwnedByRecipe.cpp
    ${repoDir}/src/model/Recipe.cpp
    ${repoDir}/src/model/RecipeAddition.cpp
    ${repoDir}/src/model/RecipeAdditionFermentable.cpp
    ${repoDir}/src/model/RecipeAdditionHop.cpp
    ${repoDir}/src/model/RecipeAdditionMisc.cpp
    ${repoDir}/src/model/RecipeAdditionYeast.cpp
    ${repoDir}/src/model/RecipeAdjustmentSalt.cpp
    ${repoDir}/src/model/RecipeUseOfWater.cpp
    ${repoDir}/src/model/Salt.cpp
    ${repoDir}/src/model/Step.cpp
    ${repoDir}/src/model/StepExtended.cpp
    ${repoDir}/src/model/Style.cpp
    ${repoDir}/src/model/Water.cpp
    ${repoDir}/src/model/Yeast.cpp
    ${repoDir}/src/qtModels/listModels/BoilListModel.cpp
    ${repoDir}/src/qtModels/listModels/EquipmentListModel.cpp
    ${repoDir}/src/qtModels/listModels/FermentableListModel.cpp
    ${repoDir}/src/qtModels/listModels/FermentationListModel.cpp
    ${repoDir}/src/qtModels/listModels/HopListModel.cpp
    ${repoDir}/src/qtModels/listModels/MashListModel.cpp
    ${repoDir}/src/qtModels/listModels/MashStepListModel.cpp
    ${repoDir}/src/qtModels/listModels/MiscListModel.cpp
    ${repoDir}/src/qtModels/listModels/RecipeAdditionFermentableListModel.cpp
    ${repoDir}/src/qtModels/listModels/RecipeAdditionHopListModel.cpp
    ${repoDir}/src/qtModels/listModels/RecipeAdditionMiscListModel.cpp
    ${repoDir}/src/qtModels/listModels/RecipeAdditionYeastListModel.cpp
    ${repoDir}/src/qtModels/listModels/RecipeAdjustmentSaltListModel.cpp
    ${repoDir}/src/qtModels/listModels/SaltListModel.cpp
    ${repoDir}/src/qtModels/listModels/StyleListModel.cpp
    ${repoDir}/src/qtModels/listModels/WaterListModel.cpp
    ${repoDir}/src/qtModels/listModels/YeastListModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/BoilSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/EquipmentSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/FermentableSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/FermentationSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/HopSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/MashSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/MiscSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionFermentableSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionHopSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionMiscSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionYeastSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/StyleSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/WaterSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/sortFilterProxyModels/YeastSortFilterProxyModel.cpp
    ${repoDir}/src/qtModels/tableModels/BoilStepTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/BoilTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/BtTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/EquipmentTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/FermentableTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/FermentationStepTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/FermentationTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/HopTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/MashStepTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/MashTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/MiscTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/RecipeAdditionFermentableTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/RecipeAdditionHopTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/RecipeAdditionMiscTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/RecipeAdditionYeastTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/RecipeAdjustmentSaltTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/SaltTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/StyleTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/WaterTableModel.cpp
    ${repoDir}/src/qtModels/tableModels/YeastTableModel.cpp
    ${repoDir}/src/serialization/ImportExport.cpp
    ${repoDir}/src/serialization/SerializationRecord.cpp
    ${repoDir}/src/serialization/json/BeerJson.cpp
    ${repoDir}/src/serialization/json/JsonCoding.cpp
    ${repoDir}/src/serialization/json/JsonMeasureableUnitsMapping.cpp
    ${repoDir}/src/serialization/json/JsonRecord.cpp
    ${repoDir}/src/serialization/json/JsonRecordDefinition.cpp
    ${repoDir}/src/serialization/json/JsonSchema.cpp
    ${repoDir}/src/serialization/json/JsonUtils.cpp
    ${repoDir}/src/serialization/json/JsonXPath.cpp
    ${repoDir}/src/serialization/xml/BeerXml.cpp
    ${repoDir}/src/serialization/xml/BtDomErrorHandler.cpp
    ${repoDir}/src/serialization/xml/XercesHelpers.cpp
    ${repoDir}/src/serialization/xml/XmlCoding.cpp
    ${repoDir}/src/serialization/xml/XmlMashRecord.cpp
    ${repoDir}/src/serialization/xml/XmlRecipeRecord.cpp
    ${repoDir}/src/serialization/xml/XmlRecord.cpp
    ${repoDir}/src/serialization/xml/XmlRecordDefinition.cpp
    ${repoDir}/src/trees/TreeFilterProxyModel.cpp

=== debian/changelog ===
brewtarget (4.0.17-1) unstable; urgency=medium

  * New upstream version 4.0.17
    - Use Qt6 instead of Qt5
    - Refresh patch
    - Add new packages to Build-Depends
  * Use wrap-and-sort -astkb
  * Update Standards-Version to 4.7.0, no changes needed
  * Update project homepage
  * Update d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 17 Feb 2025 15:54:16 +0100

=== debian/control ===
Source: brewtarget
Section: misc
Priority: optional
Maintainer: Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libboost-stacktrace-dev,
 libgl1-mesa-dev,
 libglx-dev,
 libssl-dev,
 libvalijson-dev,
 libxalan-c-dev,
 libxerces-c-dev,
 libxkbcommon-dev,
 qt6-base-dev,
 qt6-l10n-tools,
 qt6-multimedia-dev,
 qt6-svg-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-translations-l10n,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.brewtarget.beer/
Vcs-Git: https://salsa.debian.org/debian/brewtarget.git
Vcs-Browser: https://salsa.debian.org/debian/brewtarget

Package: brewtarget
Architecture: any
Depends:
 libqt6gui6,
 libqt6multimedia6,
 libqt6sql6-sqlite,
 libqt6svg6,
 libqt6svgwidgets6,
 ${misc:Depends},
 ${shlibs:Depends},
Description: GUI beer brewing software
 Brewtarget is a calculator for brewing beer. It is a Qt-based program which
 allows you to create recipes from a database of ingredients. It calculates all
 the important parameters, helps you with mash temperatures, and just makes the
 process of recipe formulation much easier.

## brewtarget 4.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -115,7 +115,7 @@
 #=======================================================================================================================
 # It's simplest to keep the project name all lower-case as it means we can use a lot more of the default settings for
 # Linux packaging (where directory names etc are expected to be all lower-case).
-project(brewtarget VERSION 4.0.17 LANGUAGES CXX)
+project(brewtarget VERSION 4.2.1 LANGUAGES CXX)
 message(STATUS "Building ${PROJECT_NAME} version ${PROJECT_VERSION}")
 message(STATUS "PROJECT_SOURCE_DIR is ${PROJECT_SOURCE_DIR}")
 # Sometimes we do need the capitalised version of the project name
@@ -123,7 +123,7 @@
 # We use this in the program, to tell users where to get support.
 set(CONFIG_GITHUB_URL "https://github.com/${capitalisedProjectName}/${projectName}")
 set(CONFIG_WEBSITE_URL "https://www.brewtarget.beer/")
-set(CONFIG_ORGANIZATION_DOMAIN "brewken.com")
+set(CONFIG_ORGANIZATION_DOMAIN "brewtarget.beer")
 
 #=======================================================================================================================
 #======================================================= Options =======================================================

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #----------------------------------------------------------------------------------------------------------------------
-# src/CMakeLists.txt is part of Brewtarget, and is copyright the following authors 2009-2024:
+# src/CMakeLists.txt is part of Brewtarget, and is copyright the following authors 2009-2025:
 #   • Aidan Roberts <aidanr67@gmail.com>
 #   • Daniel Moreno <danielm5@users.noreply.github.com>
 #   • Mark de Wever <koraq@xs4all.nl>
@@ -49,25 +49,23 @@
     ${repoDir}/src/BrewNoteWidget.cpp
     ${repoDir}/src/BtColor.cpp
     ${repoDir}/src/BtDatePopup.cpp
-    ${repoDir}/src/BtFieldType.cpp
     ${repoDir}/src/BtHorizontalTabs.cpp
     ${repoDir}/src/BtSplashScreen.cpp
     ${repoDir}/src/BtTabWidget.cpp
     ${repoDir}/src/BtTextEdit.cpp
     ${repoDir}/src/ConverterTool.cpp
-    ${repoDir}/src/HeatCalculations.cpp
     ${repoDir}/src/HelpDialog.cpp
     ${repoDir}/src/Html.cpp
     ${repoDir}/src/HydrometerTool.cpp
     ${repoDir}/src/IbuGuSlider.cpp
     ${repoDir}/src/InventoryFormatter.cpp
+    ${repoDir}/src/InventoryWindow.cpp
     ${repoDir}/src/LatestReleaseFinder.cpp
     ${repoDir}/src/Localization.cpp
     ${repoDir}/src/Logging.cpp
     ${repoDir}/src/MainWindow.cpp
     ${repoDir}/src/MashDesigner.cpp
     ${repoDir}/src/MashWizard.cpp
-    ${repoDir}/src/NamedEntitySortProxyModel.cpp
     ${repoDir}/src/OgAdjuster.cpp
     ${repoDir}/src/OptionDialog.cpp
     ${repoDir}/src/PersistentSettings.cpp
@@ -85,7 +83,7 @@
     ${repoDir}/src/TimerListDialog.cpp
     ${repoDir}/src/TimerMainDialog.cpp
     ${repoDir}/src/TimerWidget.cpp
-    ${repoDir}/src/WaterDialog.cpp
+    ${repoDir}/src/WaterProfileAdjustmentTool.cpp
     ${repoDir}/src/boiltime.cpp
     ${repoDir}/src/buttons/BoilButton.cpp
     ${repoDir}/src/buttons/EquipmentButton.cpp
@@ -94,11 +92,16 @@
     ${repoDir}/src/buttons/RecipeAttributeButton.cpp
     ${repoDir}/src/buttons/StyleButton.cpp
     ${repoDir}/src/buttons/WaterButton.cpp
+    ${repoDir}/src/catalogs/BoilCatalog.cpp
     ${repoDir}/src/catalogs/EquipmentCatalog.cpp
     ${repoDir}/src/catalogs/FermentableCatalog.cpp
+    ${repoDir}/src/catalogs/FermentationCatalog.cpp
     ${repoDir}/src/catalogs/HopCatalog.cpp
+    ${repoDir}/src/catalogs/MashCatalog.cpp
     ${repoDir}/src/catalogs/MiscCatalog.cpp
+    ${repoDir}/src/catalogs/SaltCatalog.cpp
     ${repoDir}/src/catalogs/StyleCatalog.cpp
+    ${repoDir}/src/catalogs/WaterCatalog.cpp
     ${repoDir}/src/catalogs/YeastCatalog.cpp
     ${repoDir}/src/database/BtSqlQuery.cpp
     ${repoDir}/src/database/Database.cpp
@@ -117,7 +120,7 @@
     ${repoDir}/src/editors/MashEditor.cpp
     ${repoDir}/src/editors/MashStepEditor.cpp
     ${repoDir}/src/editors/MiscEditor.cpp
-    ${repoDir}/src/editors/NamedMashEditor.cpp
+    ${repoDir}/src/editors/SaltEditor.cpp
     ${repoDir}/src/editors/StyleEditor.cpp
     ${repoDir}/src/editors/WaterEditor.cpp
     ${repoDir}/src/editors/YeastEditor.cpp
@@ -125,7 +128,9 @@
     ${repoDir}/src/measurement/ColorMethods.cpp
     ${repoDir}/src/measurement/IbuMethods.cpp
     ${repoDir}/src/measurement/Measurement.cpp
+    ${repoDir}/src/measurement/NonPhysicalQuantity.cpp
     ${repoDir}/src/measurement/PhysicalQuantity.cpp
+    ${repoDir}/src/measurement/QuantityFieldType.cpp
     ${repoDir}/src/measurement/SucroseConversion.cpp
     ${repoDir}/src/measurement/SystemOfMeasurement.cpp
     ${repoDir}/src/measurement/Unit.cpp
@@ -177,24 +182,12 @@
     ${repoDir}/src/qtModels/listModels/RecipeAdditionMiscListModel.cpp
     ${repoDir}/src/qtModels/listModels/RecipeAdditionYeastListModel.cpp
     ${repoDir}/src/qtModels/listModels/RecipeAdjustmentSaltListModel.cpp
+    ${repoDir}/src/qtModels/listModels/RecipeListModel.cpp
     ${repoDir}/src/qtModels/listModels/SaltListModel.cpp
     ${repoDir}/src/qtModels/listModels/StyleListModel.cpp
     ${repoDir}/src/qtModels/listModels/WaterListModel.cpp
     ${repoDir}/src/qtModels/listModels/YeastListModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/BoilSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/EquipmentSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/FermentableSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/FermentationSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/HopSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/MashSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/MiscSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionFermentableSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionHopSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionMiscSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/RecipeAdditionYeastSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/StyleSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/WaterSortFilterProxyModel.cpp
-    ${repoDir}/src/qtModels/sortFilterProxyModels/YeastSortFilterProxyModel.cpp
+    ${repoDir}/src/qtModels/sortFilterProxyModels/NamedEntitySortFilterProxyModel.cpp
     ${repoDir}/src/qtModels/tableModels/BoilStepTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/BoilTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/BtTableModel.cpp
@@ -211,12 +204,12 @@
     ${repoDir}/src/qtModels/tableModels/RecipeAdditionMiscTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/RecipeAdditionYeastTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/RecipeAdjustmentSaltTableModel.cpp
+    ${repoDir}/src/qtModels/tableModels/RecipeTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/SaltTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/StyleTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/WaterTableModel.cpp
     ${repoDir}/src/qtModels/tableModels/YeastTableModel.cpp
     ${repoDir}/src/serialization/ImportExport.cpp
-    ${repoDir}/src/serialization/SerializationRecord.cpp
     ${repoDir}/src/serialization/json/BeerJson.cpp
     ${repoDir}/src/serialization/json/JsonCoding.cpp
     ${repoDir}/src/serialization/json/JsonMeasureableUnitsMapping.cpp
@@ -233,4 +226,21 @@
     ${repoDir}/src/serialization/xml/XmlRecipeRecord.cpp
     ${repoDir}/src/serialization/xml/XmlRecord.cpp
     ${repoDir}/src/serialization/xml/XmlRecordDefinition.cpp
-    ${repoDir}/src/trees/TreeFilterProxyModel.cpp
+    ${repoDir}/src/trees/NamedEntityTreeModel.cpp
+    ${repoDir}/src/trees/NamedEntityTreeSortFilterProxyModel.cpp
+    ${repoDir}/src/trees/NamedEntityTreeView.cpp
+    ${repoDir}/src/trees/RecipeTreeModel.cpp
+    ${repoDir}/src/trees/RecipeTreeView.cpp
+    ${repoDir}/src/trees/TreeModel.cpp
+    ${repoDir}/src/trees/TreeModelChangeGuard.cpp
+    ${repoDir}/src/trees/TreeNode.cpp
+    ${repoDir}/src/trees/TreeView.cpp
+    ${repoDir}/src/undoRedo/SimpleUndoableUpdate.cpp
+    ${repoDir}/src/undoRedo/Undoable.cpp
+    ${repoDir}/src/utils/BtException.cpp
+    ${repoDir}/src/utils/BtStringConst.cpp
+    ${repoDir}/src/utils/BtStringStream.cpp
+    ${repoDir}/src/utils/EnumStringMapping.cpp
+    ${repoDir}/src/utils/FileSystemHelpers.cpp
+    ${repoDir}/src/utils/Fonts.cpp
+    ${repoDir}/src/utils/FuzzyCompare.cpp

=== debian/changelog ===
brewtarget (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1
  * Update debian/watch to v5
  * Remove Rules-Requires-Root from d/control
  * Update Standards-Version to 4.7.2, no changes needed
  * Replace obsolete libgl1-mesa-dev with libgl-dev
  * Remove old FSF address from d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 04 Oct 2025 17:41:41 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  cmake,
  libboost-dev,
  libboost-stacktrace-dev,
- libgl1-mesa-dev,
+ libgl-dev,
  libglx-dev,
  libssl-dev,
  libvalijson-dev,
@@ -21,8 +21,7 @@
  qt6-tools-dev,
  qt6-tools-dev-tools,
  qt6-translations-l10n,
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://www.brewtarget.beer/
 Vcs-Git: https://salsa.debian.org/debian/brewtarget.git
 Vcs-Browser: https://salsa.debian.org/debian/brewtarget

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

%:
	dh $@ --buildsystem=cmake

# Remove upstream's copyright and changelog installation, we take care of that.
# Also correct installation path of two files
execute_after_dh_auto_install:
	rm -f $(CURDIR)/debian/brewtarget/usr/share/doc/brewtarget/COPYRIGHT
	rm -f $(CURDIR)/debian/brewtarget/usr/share/doc/brewtarget/RelaseNotes.markdown
	rm -rf $(CURDIR)/debian/brewtarget/usr/share/brewtarget/applications
	rm -rf $(CURDIR)/debian/brewtarget/usr/share/brewtarget/icons/hicolor/scalable/apps

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.markdown

# Disable testing.
# Currently, all tests are failing.
override_dh_auto_test:

=== debian/watch ===
Version: 5

Template: Github
Owner: Brewtarget
Project: brewtarget
